> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pnbr.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Get review workspace

> Read the items staged in a graph workspace.

**Operation ID:** `http.graph.workspaces.get`

```http theme={null}
GET /v1/orgs/{org}/projects/{project}/graph/workspaces/{ws}
```


## OpenAPI

````yaml openapi.json GET /v1/orgs/{org}/projects/{project}/graph/workspaces/{ws}
openapi: 3.1.0
info:
  title: Penumbra API
  version: v1
  description: >-
    HTTP reference for Files, search, extraction, reviews, Graph, Shapes and
    sharing.
servers:
  - url: https://api.pnbr.io
    description: Penumbra API
security: []
paths:
  /v1/orgs/{org}/projects/{project}/graph/workspaces/{ws}:
    get:
      tags:
        - Review workspaces
      summary: Get review workspace
      description: |-
        Read the items staged in a graph workspace.

        Product guidance: [Workspace](/concepts/workspace).
      operationId: http.graph.workspaces.get
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: project
          in: path
          required: true
          schema:
            type: string
        - name: ws
          in: path
          required: true
          schema:
            type: string
        - name: limit
          in: query
          required: false
          description: How many items, 1 to 400. Defaults to 100.
          schema:
            type: string
        - name: offset
          in: query
          required: false
          description: Skip this many items. Defaults to 0.
          schema:
            type: string
      responses:
        2XX:
          description: Success.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/http_graph_workspaces_get_response'
      security:
        - bearerAuth: []
components:
  schemas:
    http_graph_workspaces_get_response:
      type: object
      properties:
        data:
          type: object
          properties:
            workspace:
              type: object
              properties:
                id:
                  type: string
                creation_origin:
                  type: string
                name:
                  type: string
                description:
                  anyOf:
                    - type: string
                    - type: 'null'
                status:
                  type: string
                  enum:
                    - open
                    - submitted
                    - applied
                    - closed
                revision:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                item_count:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                shape:
                  anyOf:
                    - type: object
                      properties:
                        shape_id:
                          type: string
                        artifact_digest:
                          type: string
                      required:
                        - shape_id
                        - artifact_digest
                      additionalProperties: {}
                    - type: 'null'
                bindings:
                  type: array
                  items:
                    type: object
                    properties:
                      shape_id:
                        type: string
                      artifact_digest:
                        type: string
                    required:
                      - shape_id
                      - artifact_digest
                    additionalProperties: {}
                bridge_set:
                  anyOf:
                    - type: object
                      properties:
                        digest:
                          type: string
                        declaration_count:
                          type: integer
                          minimum: -9007199254740991
                          maximum: 9007199254740991
                      required:
                        - digest
                        - declaration_count
                      additionalProperties: {}
                    - type: 'null'
                created_at:
                  type: string
                updated_at:
                  type: string
                applied_at:
                  anyOf:
                    - type: string
                    - type: 'null'
                replaced_by:
                  type: string
              required:
                - id
                - creation_origin
                - name
                - description
                - status
                - revision
                - item_count
                - shape
                - bindings
                - bridge_set
                - created_at
                - updated_at
                - applied_at
              additionalProperties: {}
            submission:
              type: object
              properties:
                state:
                  type: string
                  enum:
                    - not_started
                    - applied
                    - partial
                    - unresolved
                source_revision:
                  anyOf:
                    - type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    - type: 'null'
                sequence:
                  anyOf:
                    - type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    - type: 'null'
                can_submit:
                  type: boolean
                can_resume:
                  type: boolean
                receipts:
                  type: object
                  properties:
                    lifecycle:
                      anyOf:
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - graph_create
                                - graph_lifecycle
                            mode:
                              type: string
                              const: managed_atomic
                            outcome:
                              type: string
                              const: applied
                            replayed:
                              type: boolean
                            request_id:
                              type: string
                            delta_id:
                              type: string
                            project_id:
                              type: string
                            surface_id:
                              type: string
                            native_scope_id:
                              type: string
                            plan_digest:
                              type: string
                            graph_receipt_id:
                              type: string
                            graph_commit_position:
                              type: string
                            mutations:
                              type: array
                              items:
                                type: object
                                properties:
                                  resource_kind:
                                    type: string
                                    enum:
                                      - node
                                      - edge
                                  id:
                                    type: string
                                  revision:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                  operation_index:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                  mutation_kind:
                                    type: string
                                  implicit:
                                    type: boolean
                                required:
                                  - resource_kind
                                  - id
                                  - revision
                                  - operation_index
                                  - mutation_kind
                                  - implicit
                                additionalProperties: {}
                            local_refs:
                              type: object
                              propertyNames:
                                type: string
                              additionalProperties:
                                type: object
                                properties:
                                  resource_kind:
                                    type: string
                                    enum:
                                      - node
                                      - edge
                                  id:
                                    type: string
                                  revision:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                required:
                                  - resource_kind
                                  - id
                                  - revision
                                additionalProperties: {}
                            target_revision:
                              type: string
                            effect_receipt_ref:
                              type: string
                            timings_ms:
                              type: object
                              propertyNames:
                                type: string
                              additionalProperties:
                                type: number
                          required:
                            - kind
                            - mode
                            - outcome
                            - replayed
                            - request_id
                            - delta_id
                            - project_id
                            - surface_id
                            - native_scope_id
                            - plan_digest
                            - graph_receipt_id
                            - graph_commit_position
                            - local_refs
                            - target_revision
                            - effect_receipt_ref
                            - timings_ms
                          additionalProperties: {}
                        - type: 'null'
                    create:
                      anyOf:
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - graph_create
                                - graph_lifecycle
                            mode:
                              type: string
                              const: managed_atomic
                            outcome:
                              type: string
                              const: applied
                            replayed:
                              type: boolean
                            request_id:
                              type: string
                            delta_id:
                              type: string
                            project_id:
                              type: string
                            surface_id:
                              type: string
                            native_scope_id:
                              type: string
                            plan_digest:
                              type: string
                            graph_receipt_id:
                              type: string
                            graph_commit_position:
                              type: string
                            mutations:
                              type: array
                              items:
                                type: object
                                properties:
                                  resource_kind:
                                    type: string
                                    enum:
                                      - node
                                      - edge
                                  id:
                                    type: string
                                  revision:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                  operation_index:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                  mutation_kind:
                                    type: string
                                  implicit:
                                    type: boolean
                                required:
                                  - resource_kind
                                  - id
                                  - revision
                                  - operation_index
                                  - mutation_kind
                                  - implicit
                                additionalProperties: {}
                            local_refs:
                              type: object
                              propertyNames:
                                type: string
                              additionalProperties:
                                type: object
                                properties:
                                  resource_kind:
                                    type: string
                                    enum:
                                      - node
                                      - edge
                                  id:
                                    type: string
                                  revision:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                required:
                                  - resource_kind
                                  - id
                                  - revision
                                additionalProperties: {}
                            target_revision:
                              type: string
                            effect_receipt_ref:
                              type: string
                            timings_ms:
                              type: object
                              propertyNames:
                                type: string
                              additionalProperties:
                                type: number
                          required:
                            - kind
                            - mode
                            - outcome
                            - replayed
                            - request_id
                            - delta_id
                            - project_id
                            - surface_id
                            - native_scope_id
                            - plan_digest
                            - graph_receipt_id
                            - graph_commit_position
                            - local_refs
                            - target_revision
                            - effect_receipt_ref
                            - timings_ms
                          additionalProperties: {}
                        - type: 'null'
                    link:
                      anyOf:
                        - type: object
                          properties:
                            kind:
                              type: string
                              enum:
                                - graph_create
                                - graph_lifecycle
                            mode:
                              type: string
                              const: managed_atomic
                            outcome:
                              type: string
                              const: applied
                            replayed:
                              type: boolean
                            request_id:
                              type: string
                            delta_id:
                              type: string
                            project_id:
                              type: string
                            surface_id:
                              type: string
                            native_scope_id:
                              type: string
                            plan_digest:
                              type: string
                            graph_receipt_id:
                              type: string
                            graph_commit_position:
                              type: string
                            mutations:
                              type: array
                              items:
                                type: object
                                properties:
                                  resource_kind:
                                    type: string
                                    enum:
                                      - node
                                      - edge
                                  id:
                                    type: string
                                  revision:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                  operation_index:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                  mutation_kind:
                                    type: string
                                  implicit:
                                    type: boolean
                                required:
                                  - resource_kind
                                  - id
                                  - revision
                                  - operation_index
                                  - mutation_kind
                                  - implicit
                                additionalProperties: {}
                            local_refs:
                              type: object
                              propertyNames:
                                type: string
                              additionalProperties:
                                type: object
                                properties:
                                  resource_kind:
                                    type: string
                                    enum:
                                      - node
                                      - edge
                                  id:
                                    type: string
                                  revision:
                                    type: integer
                                    minimum: -9007199254740991
                                    maximum: 9007199254740991
                                required:
                                  - resource_kind
                                  - id
                                  - revision
                                additionalProperties: {}
                            target_revision:
                              type: string
                            effect_receipt_ref:
                              type: string
                            timings_ms:
                              type: object
                              propertyNames:
                                type: string
                              additionalProperties:
                                type: number
                          required:
                            - kind
                            - mode
                            - outcome
                            - replayed
                            - request_id
                            - delta_id
                            - project_id
                            - surface_id
                            - native_scope_id
                            - plan_digest
                            - graph_receipt_id
                            - graph_commit_position
                            - local_refs
                            - target_revision
                            - effect_receipt_ref
                            - timings_ms
                          additionalProperties: {}
                        - type: 'null'
                  required:
                    - lifecycle
                    - create
                    - link
                  additionalProperties: {}
                error:
                  anyOf:
                    - type: string
                    - type: 'null'
              required:
                - state
                - source_revision
                - sequence
                - can_submit
                - can_resume
                - receipts
                - error
              additionalProperties: {}
            items:
              type: array
              items:
                oneOf:
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: entity
                      handle:
                        type: string
                      ref:
                        anyOf:
                          - type: string
                          - type: 'null'
                      type_name:
                        type: string
                      name:
                        type: string
                      properties:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties: {}
                      binding:
                        type: object
                        properties:
                          shape_id:
                            type: string
                          artifact_digest:
                            type: string
                        required:
                          - shape_id
                          - artifact_digest
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - ref
                      - type_name
                      - name
                      - properties
                      - binding
                      - evidence
                      - created_at
                    additionalProperties: {}
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: relationship
                      handle:
                        type: string
                      ref:
                        anyOf:
                          - type: string
                          - type: 'null'
                      edge_type:
                        type: string
                      source:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      target:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      properties:
                        type: object
                        propertyNames:
                          type: string
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - ref
                      - edge_type
                      - source
                      - target
                      - properties
                      - evidence
                      - created_at
                    additionalProperties: {}
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: hydrated_node
                      handle:
                        type: string
                      node_id:
                        type: string
                      witness_revision:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      intent:
                        type: string
                        enum:
                          - update
                          - delete
                      snapshot:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - node_id
                      - witness_revision
                      - intent
                      - snapshot
                      - evidence
                      - created_at
                    additionalProperties: {}
                  - type: object
                    properties:
                      kind:
                        type: string
                        const: hydrated_edge
                      handle:
                        type: string
                      edge_id:
                        type: string
                      witness_revision:
                        type: integer
                        minimum: -9007199254740991
                        maximum: 9007199254740991
                      intent:
                        type: string
                        enum:
                          - update
                          - delete
                      snapshot:
                        type: object
                        properties: {}
                        additionalProperties: {}
                      evidence:
                        type: array
                        items:
                          type: object
                          properties: {}
                          additionalProperties: {}
                      created_at:
                        type: string
                    required:
                      - kind
                      - handle
                      - edge_id
                      - witness_revision
                      - intent
                      - snapshot
                      - evidence
                      - created_at
                    additionalProperties: {}
            total_items:
              type: integer
              minimum: -9007199254740991
              maximum: 9007199254740991
            next_cursor:
              anyOf:
                - type: string
                - type: 'null'
          required:
            - workspace
            - submission
            - items
            - total_items
            - next_cursor
          additionalProperties: {}
      required:
        - data
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.